// license-header java merge-point
//
// Attention: Generated code! Do not modify by hand!
// Generated by: SpringDao.vsl in andromda-spring-cartridge.
//
package fr.ifremer.adagio.core.dao.referential.gear;

import fr.ifremer.adagio.core.dao.Search;
import java.sql.Timestamp;
import java.util.Collection;
import java.util.Set;
import org.andromda.spring.PaginationResult;

/**
 * Une classification d'engin permet le regroupement d'un ensemble cohérent d'engin.
 * Exemple :
 * - Engin FAO, appellée aussi CSITEP (Classification Standard Internationale Type des Engins de
 * Pêche), ou, en anglais : International Standard Statistical Classification of Fishing Gear
 * (ISSCFG) : ftp://ftp.fao.org/FI/DOCUMENT/cwp/handbook/annex/AnnexM1fishinggear.pdf
 * - Engin CNTS (DPMA SIP)
 * - Engin EU (basé sur les engins FAO, mais adapté au contexte réglementaire européen) :
 * exemple : 	- extension pour signifier 'pas d'engin' : NO
 * extension pour signifier 'engin inconnu' : NK (Not Known)
 * 'ligne avec canne (...)' : BTF (code utilisé pour des données historique)
 * - 'Engin EU Corpus' pour le traitment (cf DRE_CORPUS dans tmpsih)
 * - Engin Métier Ifremer (basé sur la classification FAO, et etendue aux besoins Ifremer/francais)
 * Pour ObsMer, la classification utilisée est : FAO
 * Pour les observations au débarquement, la classification utilisée est : FAO + CNTS (pour
 * recroiser avec les déclarations)
 * @see GearClassification
 */
public interface GearClassificationDao
{
    /**
     * This constant is used as a transformation flag; entities can be converted automatically into value objects
     * or other types, different methods in a class implementing this interface support this feature: look for
     * an <code>int</code> parameter called <code>transform</code>.
     * <p>
     * This specific flag denotes no transformation will occur.
     */
    public static final int TRANSFORM_NONE = 0;


    /**
     * Transforms the given results to a collection of {@link GearClassification}
     * instances (this is useful when the returned results contains a row of data and you want just entities only).
     *
     * @param results the query results.
     */
    public void toEntities(final Collection<?> results);

    /**
     * Gets an instance of GearClassification from the persistent store.
     * @param id
     * @return GearClassification
     */
    public GearClassification get(Integer id);

    /**
     * <p>
     * Does the same thing as {@link #get(Integer)} with an
     * additional flag called <code>transform</code>. If this flag is set to <code>TRANSFORM_NONE</code> then
     * the returned entity will <strong>NOT</strong> be transformed. If this flag is any of the other constants
     * defined in this class then the result <strong>WILL BE</strong> passed through an operation which can
     * optionally transform the entity (into a value object for example). By default, transformation does
     * not occur.
     * </p>
     *
     * @param transform flag to determine transformation type.
     * @param id the identifier of the entity to get.
     * @return either the entity or the object transformed from the entity.
     */
    public Object get(int transform, Integer id);

    /**
     * Loads an instance of GearClassification from the persistent store.
     * @param id
     * @return GearClassification
     */
    public GearClassification load(Integer id);

    /**
     * <p>
     * Does the same thing as {@link #load(Integer)} with an
     * additional flag called <code>transform</code>. If this flag is set to <code>TRANSFORM_NONE</code> then
     * the returned entity will <strong>NOT</strong> be transformed. If this flag is any of the other constants
     * defined in this class then the result <strong>WILL BE</strong> passed through an operation which can
     * optionally transform the entity (into a value object for example). By default, transformation does
     * not occur.
     * </p>
     *
     * @param transform flag to determine transformation type.
     * @param id the identifier of the entity to load.
     * @return either the entity or the object transformed from the entity.
     */
    public Object load(int transform, Integer id);

    /**
     * Loads all entities of type {@link GearClassification}.
     *
     * @return the loaded entities.
     */
    public Collection<GearClassification> loadAll();

    /**
     * <p>
     * Does the same thing as {@link #loadAll()} with an
     * additional flag called <code>transform</code>. If this flag is set to <code>TRANSFORM_NONE</code> then
     * the returned entity will <strong>NOT</strong> be transformed. If this flag is any of the other constants
     * defined here then the result <strong>WILL BE</strong> passed through an operation which can optionally
     * transform the entity (into a value object for example). By default, transformation does
     * not occur.
     * </p>
     *
     * @param transform the flag indicating what transformation to use.
     * @return the loaded entities.
     */
    public Collection<?> loadAll(final int transform);

    /**
     * <p>
     * Does the same thing as {@link #loadAll()} with an
     * additional two arguments called <code>pageNumber</code> and <code>pageSize</code>. The <code>pageNumber</code>
     * argument allows you to specify the page number when you are paging the results and the pageSize allows you to specify the size of the
     * page retrieved.
     * </p>
     *
     * @param pageNumber the page number to retrieve when paging results.
     * @param pageSize the size of the page to retrieve when paging results.
     * @return the loaded entities.
     */
    public Collection<?> loadAll(final int pageNumber, final int pageSize);

    /**
     * <p>
     * Does the same thing as {@link #loadAll(int)} with an
     * additional two arguments called <code>pageNumber</code> and <code>pageSize</code>. The <code>pageNumber</code>
     * argument allows you to specify the page number when you are paging the results and the pageSize allows you to specify the size of the
     * page retrieved.
     * </p>
     *
     * @param transform the flag indicating what transformation to use.
     * @param pageNumber the page number to retrieve when paging results.
     * @param pageSize the size of the page to retrieve when paging results.
     * @return the loaded entities.
     */
    public Collection<?> loadAll(final int transform, final int pageNumber, final int pageSize);

    /**
     * Creates an instance of GearClassification and adds it to the persistent store.
     * @param gearClassification
     * @return GearClassification
     */
    public GearClassification create(GearClassification gearClassification);

    /**
     * <p>
     * Does the same thing as {@link #create(GearClassification)} with an
     * additional flag called <code>transform</code>. If this flag is set to <code>TRANSFORM_NONE</code> then
     * the returned entity will <strong>NOT</strong> be transformed. If this flag is any of the other constants
     * defined here then the result <strong>WILL BE</strong> passed through an operation which can optionally
     * transform the entity (into a value object for example). By default, transformation does
     * not occur.
     * </p>
     * @param transform
     * @param gearClassification
     * @return Object
     */
    public Object create(int transform, GearClassification gearClassification);

    /**
     * Creates a new instance of GearClassification and adds
     * from the passed in <code>entities</code> collection
     *
     * @param entities the collection of GearClassification
     * instances to create.
     *
     * @return the created instances.
     */
    public Collection<GearClassification> create(Collection<GearClassification> entities);

    /**
     * <p>
     * Does the same thing as {@link #create(GearClassification)} with an
     * additional flag called <code>transform</code>. If this flag is set to <code>TRANSFORM_NONE</code> then
     * the returned entity will <strong>NOT</strong> be transformed. If this flag is any of the other constants
     * defined here then the result <strong>WILL BE</strong> passed through an operation which can optionally
     * transform the entities (into value objects for example). By default, transformation does
     * not occur.
     * </p>
     * @param transform
     * @param entities
     * @return Collection
     */
    public Collection<?> create(int transform, Collection<GearClassification> entities);

    /**
     * <p>
     * Creates a new <code>GearClassification</code>
     * instance from <strong>all</strong> attributes and adds it to
     * the persistent store.
     * </p>
     * @param name 
     * @param description 
     * @param isAggregation <html>
<head>
</head>
<body>
<p>
TODO : confirmer si l'attribut est utile
</p>
<p>
, dans la mesure ou les strat&#233;gies peuvent permettrent de choisir la
classification &#224; utiliser.<br>
</p>
<p>
Indicateur permettant de savoir si la classification est utilis&#233;
uniquement dans le cadre de donn&#233;es d'agr&#233;gation.
</p>
</body>
</html>
     * @param updateDate 
     * @return GearClassification
     */
    public GearClassification create(
        String name,
        String description,
        Boolean isAggregation,
        Timestamp updateDate);

    /**
     * <p>
     * Does the same thing as {@link #create(String, String, Boolean, Timestamp)} with an
     * additional flag called <code>transform</code>. If this flag is set to <code>TRANSFORM_NONE</code> then
     * the returned entity will <strong>NOT</strong> be transformed. If this flag is any of the other constants
     * defined here then the result <strong>WILL BE</strong> passed through an operation which can optionally
     * transform the entity (into a value object for example). By default, transformation does
     * not occur.
     * </p>
     * @param transform
     * @param name 
     * @param description 
     * @param isAggregation <html>
<head>
</head>
<body>
<p>
TODO : confirmer si l'attribut est utile
</p>
<p>
, dans la mesure ou les strat&#233;gies peuvent permettrent de choisir la
classification &#224; utiliser.<br>
</p>
<p>
Indicateur permettant de savoir si la classification est utilis&#233;
uniquement dans le cadre de donn&#233;es d'agr&#233;gation.
</p>
</body>
</html>
     * @param updateDate 
     * @return GearClassification
     */
    public Object create(
        int transform,
        String name,
        String description,
        Boolean isAggregation,
        Timestamp updateDate);


    /**
     * Updates the <code>gearClassification</code> instance in the persistent store.
     * @param gearClassification
     */
    public void update(GearClassification gearClassification);

    /**
     * Updates all instances in the <code>entities</code> collection in the persistent store.
     * @param entities
     */
    public void update(Collection<GearClassification> entities);

    /**
     * Removes the instance of GearClassification from the persistent store.
     * @param gearClassification
     */
    public void remove(GearClassification gearClassification);

    /**
     * Removes the instance of GearClassification having the given
     * <code>identifier</code> from the persistent store.
     * @param id
     */
    public void remove(Integer id);

    /**
     * Removes all entities in the given <code>entities</code> collection.
     * @param entities
     */
    public void remove(Collection<GearClassification> entities);


    /**
     * Does the same thing as {@link #search(int, Search)} but with an
     * additional two flags called <code>pageNumber</code> and <code>pageSize</code>. These flags allow you to
     * limit your data to a specified page number and size.
     *
     * @param transform the transformation flag.
     * @param pageNumber the page number in the data to retrieve
     * @param pageSize the size of the page to retrieve.
     * @param search the search object which provides the search parameters and pagination specification.
     * @return any found results from the search wrapped in a {@link PaginationResult} instance.
     */
    public PaginationResult search(final int transform, final int pageNumber, final int pageSize, final Search search);

    /**
     * Does the same thing as {@link #search(Search)} but with an
     * additional two flags called <code>pageNumber</code> and <code>pageSize</code>. These flags allow you to
     * limit your data to a specified page number and size.
     *
     * @param pageNumber the page number in the data to retrieve
     * @param pageSize the size of the page to retrieve.
     * @param search the search object which provides the search parameters and pagination specification.
     * @return any found results from the search wrapped in a {@link PaginationResult} instance.
     */
    public PaginationResult search(final int pageNumber, final int pageSize, final Search search);

    /**
     * Does the same thing as {@link #search(Search)} but with an
     * additional flag called <code>transform</code>. If this flag is set to <code>TRANSFORM_NONE</code> then
     * finder results will <strong>NOT</strong> be transformed during retrieval.
     * If this flag is any of the other constants defined here
     * then results <strong>WILL BE</strong> passed through an operation which can optionally
     * transform the entities (into value objects for example). By default, transformation does
     * not occur.
     *
     * @param transform the transformation flag.
     * @param search the search object which provides the search parameters and pagination specification.
     * @return any found results from the search.
     */
    public Set<?> search(final int transform, final Search search);

    /**
     * Performs a search using the parameters specified in the given <code>search</code> object.
     *
     * @param search the search object which provides the search parameters and pagination specification.
     * @return any found results from the search.
     */
    public Set<GearClassification> search(final Search search);

    /**
     * Allows transformation of entities into value objects
     * (or something else for that matter), when the <code>transform</code>
     * flag is set to one of the constants defined in <code>fr.ifremer.adagio.core.dao.referential.gear.GearClassificationDao</code>, please note
     * that the {@link #TRANSFORM_NONE} constant denotes no transformation, so the entity itself
     * will be returned.
     *
     * If the integer argument value is unknown {@link #TRANSFORM_NONE} is assumed.
     *
     * @param transform one of the constants declared in {@link fr.ifremer.adagio.core.dao.referential.gear.GearClassificationDao}
     * @param entity an entity that was found
     * @return the transformed entity (i.e. new value object, etc)
     * @see #transformEntities(int,Collection)
     */
    public Object transformEntity(final int transform, final GearClassification entity);

    /**
     * Transforms a collection of entities using the
     * {@link #transformEntity(int,GearClassification)}
     * method. This method does not instantiate a new collection.
     * <p>
     * This method is to be used internally only.
     *
     * @param transform one of the constants declared in <code>fr.ifremer.adagio.core.dao.referential.gear.GearClassificationDao</code>
     * @param entities the collection of entities to transform
     * @see #transformEntity(int,GearClassification)
     */
    public void transformEntities(final int transform, final Collection<?> entities);

    // spring-dao merge-point
}