// license-header java merge-point
//
// Attention: Generated code! Do not modify by hand!
// Generated by: SpringDao.vsl in andromda-spring-cartridge.
//
package fr.ifremer.adagio.core.dao.referential.regulation;

import fr.ifremer.adagio.core.dao.Search;
import fr.ifremer.adagio.core.dao.referential.location.Location;
import fr.ifremer.adagio.core.dao.referential.pmfm.Unit;
import fr.ifremer.adagio.core.dao.referential.taxon.TaxonGroup;
import java.sql.Timestamp;
import java.util.Collection;
import java.util.Set;
import org.andromda.spring.PaginationResult;

/**
 * <html>
 * <head>
 * </head>
 * <body>
 * <p>
 * The lowest individual size allowed in landings or markets. Established
 * by fishery management and enforced through control at landing sites or
 * markets, it is intended to minimize the catch of small (undersized) fish
 * or juveniles giving them a better chance to grow before being vulnerable
 * to fishing. Based on yield per recruit considerations and models, it
 * aims at avoiding or correcting growth overfishing
 * </p>
 * <p>
 * </p>
 * <p>
 * Other Definitions
 * </p>
 * <p>
 * Legislated size below which individuals of some fish species, if caught,
 * are not to be retained
 * </p>
 * <p>
 * </p>
 * <p>
 * <font size="3"><u><i>Comonwealth of Australia (1997):</i></u><i>
 * http://www.brs.gov.au/fish/gloss.html
 * </i></font><br><font size="3"><i>
 * </i></font><br>    </p>
 * <p>
 * </p>
 * <p>
 * A fishery management control on size at landing (or in the market)
 * intended to minimize the catch of small (undersized) fish or juveniles
 * giving them a better chance to grow before being vulnerable to fishing.
 * Based on yield per recruit considerations and models, it aims at
 * avoiding or correcting growth overfishing.
 * </p>
 * <p>
 * </p>
 * <p>
 * <u><i>Restrepo V. (1999):</i></u><i> Annotated Glossary of Terms in
 * Executive Summary Reports of the International Commission for the
 * Conservation of Atlantic Tunas&#180; Standing Committee on Research and
 * Statistics (SCRS). ICCAT .</i>
 * </p>
 * </body>
 * </html>
 * @see MinimumSizeAllowed
 */
public interface MinimumSizeAllowedDao
{
    /**
     * This constant is used as a transformation flag; entities can be converted automatically into value objects
     * or other types, different methods in a class implementing this interface support this feature: look for
     * an <code>int</code> parameter called <code>transform</code>.
     * <p>
     * This specific flag denotes no transformation will occur.
     */
    public static final int TRANSFORM_NONE = 0;


    /**
     * Transforms the given results to a collection of {@link MinimumSizeAllowed}
     * instances (this is useful when the returned results contains a row of data and you want just entities only).
     *
     * @param results the query results.
     */
    public void toEntities(final Collection<?> results);

    /**
     * Gets an instance of MinimumSizeAllowed from the persistent store.
     * @param id
     * @return MinimumSizeAllowed
     */
    public MinimumSizeAllowed get(Integer id);

    /**
     * <p>
     * Does the same thing as {@link #get(Integer)} with an
     * additional flag called <code>transform</code>. If this flag is set to <code>TRANSFORM_NONE</code> then
     * the returned entity will <strong>NOT</strong> be transformed. If this flag is any of the other constants
     * defined in this class then the result <strong>WILL BE</strong> passed through an operation which can
     * optionally transform the entity (into a value object for example). By default, transformation does
     * not occur.
     * </p>
     *
     * @param transform flag to determine transformation type.
     * @param id the identifier of the entity to get.
     * @return either the entity or the object transformed from the entity.
     */
    public Object get(int transform, Integer id);

    /**
     * Loads an instance of MinimumSizeAllowed from the persistent store.
     * @param id
     * @return MinimumSizeAllowed
     */
    public MinimumSizeAllowed load(Integer id);

    /**
     * <p>
     * Does the same thing as {@link #load(Integer)} with an
     * additional flag called <code>transform</code>. If this flag is set to <code>TRANSFORM_NONE</code> then
     * the returned entity will <strong>NOT</strong> be transformed. If this flag is any of the other constants
     * defined in this class then the result <strong>WILL BE</strong> passed through an operation which can
     * optionally transform the entity (into a value object for example). By default, transformation does
     * not occur.
     * </p>
     *
     * @param transform flag to determine transformation type.
     * @param id the identifier of the entity to load.
     * @return either the entity or the object transformed from the entity.
     */
    public Object load(int transform, Integer id);

    /**
     * Loads all entities of type {@link MinimumSizeAllowed}.
     *
     * @return the loaded entities.
     */
    public Collection<MinimumSizeAllowed> loadAll();

    /**
     * <p>
     * Does the same thing as {@link #loadAll()} with an
     * additional flag called <code>transform</code>. If this flag is set to <code>TRANSFORM_NONE</code> then
     * the returned entity will <strong>NOT</strong> be transformed. If this flag is any of the other constants
     * defined here then the result <strong>WILL BE</strong> passed through an operation which can optionally
     * transform the entity (into a value object for example). By default, transformation does
     * not occur.
     * </p>
     *
     * @param transform the flag indicating what transformation to use.
     * @return the loaded entities.
     */
    public Collection<?> loadAll(final int transform);

    /**
     * <p>
     * Does the same thing as {@link #loadAll()} with an
     * additional two arguments called <code>pageNumber</code> and <code>pageSize</code>. The <code>pageNumber</code>
     * argument allows you to specify the page number when you are paging the results and the pageSize allows you to specify the size of the
     * page retrieved.
     * </p>
     *
     * @param pageNumber the page number to retrieve when paging results.
     * @param pageSize the size of the page to retrieve when paging results.
     * @return the loaded entities.
     */
    public Collection<?> loadAll(final int pageNumber, final int pageSize);

    /**
     * <p>
     * Does the same thing as {@link #loadAll(int)} with an
     * additional two arguments called <code>pageNumber</code> and <code>pageSize</code>. The <code>pageNumber</code>
     * argument allows you to specify the page number when you are paging the results and the pageSize allows you to specify the size of the
     * page retrieved.
     * </p>
     *
     * @param transform the flag indicating what transformation to use.
     * @param pageNumber the page number to retrieve when paging results.
     * @param pageSize the size of the page to retrieve when paging results.
     * @return the loaded entities.
     */
    public Collection<?> loadAll(final int transform, final int pageNumber, final int pageSize);

    /**
     * Creates an instance of MinimumSizeAllowed and adds it to the persistent store.
     * @param minimumSizeAllowed
     * @return MinimumSizeAllowed
     */
    public MinimumSizeAllowed create(MinimumSizeAllowed minimumSizeAllowed);

    /**
     * <p>
     * Does the same thing as {@link #create(MinimumSizeAllowed)} with an
     * additional flag called <code>transform</code>. If this flag is set to <code>TRANSFORM_NONE</code> then
     * the returned entity will <strong>NOT</strong> be transformed. If this flag is any of the other constants
     * defined here then the result <strong>WILL BE</strong> passed through an operation which can optionally
     * transform the entity (into a value object for example). By default, transformation does
     * not occur.
     * </p>
     * @param transform
     * @param minimumSizeAllowed
     * @return Object
     */
    public Object create(int transform, MinimumSizeAllowed minimumSizeAllowed);

    /**
     * Creates a new instance of MinimumSizeAllowed and adds
     * from the passed in <code>entities</code> collection
     *
     * @param entities the collection of MinimumSizeAllowed
     * instances to create.
     *
     * @return the created instances.
     */
    public Collection<MinimumSizeAllowed> create(Collection<MinimumSizeAllowed> entities);

    /**
     * <p>
     * Does the same thing as {@link #create(MinimumSizeAllowed)} with an
     * additional flag called <code>transform</code>. If this flag is set to <code>TRANSFORM_NONE</code> then
     * the returned entity will <strong>NOT</strong> be transformed. If this flag is any of the other constants
     * defined here then the result <strong>WILL BE</strong> passed through an operation which can optionally
     * transform the entities (into value objects for example). By default, transformation does
     * not occur.
     * </p>
     * @param transform
     * @param entities
     * @return Collection
     */
    public Collection<?> create(int transform, Collection<MinimumSizeAllowed> entities);

    /**
     * <p>
     * Creates a new <code>MinimumSizeAllowed</code>
     * instance from <strong>all</strong> attributes and adds it to
     * the persistent store.
     * </p>
     * @param minimumSize 
     * @param updateDate 
     * @return MinimumSizeAllowed
     */
    public MinimumSizeAllowed create(
        Float minimumSize,
        Timestamp updateDate);

    /**
     * <p>
     * Does the same thing as {@link #create(Float, Timestamp)} with an
     * additional flag called <code>transform</code>. If this flag is set to <code>TRANSFORM_NONE</code> then
     * the returned entity will <strong>NOT</strong> be transformed. If this flag is any of the other constants
     * defined here then the result <strong>WILL BE</strong> passed through an operation which can optionally
     * transform the entity (into a value object for example). By default, transformation does
     * not occur.
     * </p>
     * @param transform
     * @param minimumSize 
     * @param updateDate 
     * @return MinimumSizeAllowed
     */
    public Object create(
        int transform,
        Float minimumSize,
        Timestamp updateDate);

    /**
     * <p>
     * Creates a new <code>MinimumSizeAllowed</code>
     * instance from only <strong>required</strong> properties (attributes
     * and association ends) and adds it to the persistent store.
     * </p>
     * @param corpus
     * @param locations
     * @param minimumSize
     * @param sizeUnit
     * @param taxonGroup
     * @return MinimumSizeAllowed
     */
    public MinimumSizeAllowed create(
        Corpus corpus,
        Collection<Location> locations,
        Float minimumSize,
        Unit sizeUnit,
        TaxonGroup taxonGroup);

    /**
     * <p>
     * Does the same thing as {@link #create(Float)} with an
     * additional flag called <code>transform</code>. If this flag is set to <code>TRANSFORM_NONE</code> then
     * the returned entity will <strong>NOT</strong> be transformed. If this flag is any of the other constants
     * defined here then the result <strong>WILL BE</strong> passed through an operation which can optionally
     * transform the entity (into a value object for example). By default, transformation does
     * not occur.
     * </p>
     * @param transform flag to determine transformation type.
     * @param corpus
     * @param locations
     * @param minimumSize
     * @param sizeUnit
     * @param taxonGroup
     * @return Object
     */
    public Object create(
        int transform,
        Corpus corpus,
        Collection<Location> locations,
        Float minimumSize,
        Unit sizeUnit,
        TaxonGroup taxonGroup);

    /**
     * Updates the <code>minimumSizeAllowed</code> instance in the persistent store.
     * @param minimumSizeAllowed
     */
    public void update(MinimumSizeAllowed minimumSizeAllowed);

    /**
     * Updates all instances in the <code>entities</code> collection in the persistent store.
     * @param entities
     */
    public void update(Collection<MinimumSizeAllowed> entities);

    /**
     * Removes the instance of MinimumSizeAllowed from the persistent store.
     * @param minimumSizeAllowed
     */
    public void remove(MinimumSizeAllowed minimumSizeAllowed);

    /**
     * Removes the instance of MinimumSizeAllowed having the given
     * <code>identifier</code> from the persistent store.
     * @param id
     */
    public void remove(Integer id);

    /**
     * Removes all entities in the given <code>entities</code> collection.
     * @param entities
     */
    public void remove(Collection<MinimumSizeAllowed> entities);


    /**
     * Does the same thing as {@link #search(int, Search)} but with an
     * additional two flags called <code>pageNumber</code> and <code>pageSize</code>. These flags allow you to
     * limit your data to a specified page number and size.
     *
     * @param transform the transformation flag.
     * @param pageNumber the page number in the data to retrieve
     * @param pageSize the size of the page to retrieve.
     * @param search the search object which provides the search parameters and pagination specification.
     * @return any found results from the search wrapped in a {@link PaginationResult} instance.
     */
    public PaginationResult search(final int transform, final int pageNumber, final int pageSize, final Search search);

    /**
     * Does the same thing as {@link #search(Search)} but with an
     * additional two flags called <code>pageNumber</code> and <code>pageSize</code>. These flags allow you to
     * limit your data to a specified page number and size.
     *
     * @param pageNumber the page number in the data to retrieve
     * @param pageSize the size of the page to retrieve.
     * @param search the search object which provides the search parameters and pagination specification.
     * @return any found results from the search wrapped in a {@link PaginationResult} instance.
     */
    public PaginationResult search(final int pageNumber, final int pageSize, final Search search);

    /**
     * Does the same thing as {@link #search(Search)} but with an
     * additional flag called <code>transform</code>. If this flag is set to <code>TRANSFORM_NONE</code> then
     * finder results will <strong>NOT</strong> be transformed during retrieval.
     * If this flag is any of the other constants defined here
     * then results <strong>WILL BE</strong> passed through an operation which can optionally
     * transform the entities (into value objects for example). By default, transformation does
     * not occur.
     *
     * @param transform the transformation flag.
     * @param search the search object which provides the search parameters and pagination specification.
     * @return any found results from the search.
     */
    public Set<?> search(final int transform, final Search search);

    /**
     * Performs a search using the parameters specified in the given <code>search</code> object.
     *
     * @param search the search object which provides the search parameters and pagination specification.
     * @return any found results from the search.
     */
    public Set<MinimumSizeAllowed> search(final Search search);

    /**
     * Allows transformation of entities into value objects
     * (or something else for that matter), when the <code>transform</code>
     * flag is set to one of the constants defined in <code>fr.ifremer.adagio.core.dao.referential.regulation.MinimumSizeAllowedDao</code>, please note
     * that the {@link #TRANSFORM_NONE} constant denotes no transformation, so the entity itself
     * will be returned.
     *
     * If the integer argument value is unknown {@link #TRANSFORM_NONE} is assumed.
     *
     * @param transform one of the constants declared in {@link fr.ifremer.adagio.core.dao.referential.regulation.MinimumSizeAllowedDao}
     * @param entity an entity that was found
     * @return the transformed entity (i.e. new value object, etc)
     * @see #transformEntities(int,Collection)
     */
    public Object transformEntity(final int transform, final MinimumSizeAllowed entity);

    /**
     * Transforms a collection of entities using the
     * {@link #transformEntity(int,MinimumSizeAllowed)}
     * method. This method does not instantiate a new collection.
     * <p>
     * This method is to be used internally only.
     *
     * @param transform one of the constants declared in <code>fr.ifremer.adagio.core.dao.referential.regulation.MinimumSizeAllowedDao</code>
     * @param entities the collection of entities to transform
     * @see #transformEntity(int,MinimumSizeAllowed)
     */
    public void transformEntities(final int transform, final Collection<?> entities);

    // spring-dao merge-point
}